VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegistryFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"RegistryEntry"
Attribute VB_Ext_KEY = "Member0" ,"RegistryEntry"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'local variable to hold collection
Private mCol As Collection
Public Function CheckCellForEncroachment(ByRef AWObjectsCol As AWObjects, CellX As Long, CellZ As Long, CitNum As Long)
    Dim TempX As Long, TempZ As Long, XCounter As Long, ZCounter As Long
    Dim XCheck As Boolean
    Dim ZCheck As Boolean
    'AWObj is an object representing an AW object - X here is the X coordinate, Z is the Z coordinate
    For Each AWObj In AWObjectsCol
        If AWObj.Owner <> CitNum Then
            'This part takes care of the case when the object is actually in the cell
            If AWObj.X >= CellX And AWObj.X <= CellX + 1000 And AWObj.Z >= CellZ And AWObj.Z <= CellZ + 1000 Then
                CheckCellForEncroachment = True
                Exit Function
            End If
            TempX = mCol(AWObj.Model).X
            TempZ = mCol(AWObj.Model).Z
            XCheck = False
            ZCheck = False
            'for loops are necessary in the case that an object fills more than two cells
            'in this case, an object could acutally encroach by having both ends out of the cell
            'in question, while the middle is in the building
            For XCounter = TempX To 0 Step -1000
                For ZCounter = TempZ To 0 Step -1000
                    'coordinates ofobjects in negative numbered cells are LOWER than the cell coordinate,
                    'while the coordinates of objects in positive numbered cells are HIGHER than the coordinate
                    'this, either the slow abs() function must be used, or an if else clause is needed
                    If AWObj.X > 0 Then
                        If (AWObj.X - TempX > CellX And AWObj.X - TempX <= CellX + 1000) Or (AWObj.X + TempX > CellX And AWObj.X + TempX <= CellX + 1000) Then
                            XCheck = True
                        End If
                    Else
                        If (AWObj.X - TempX < CellX And AWObj.X - TempX >= CellX - 1000) Or (AWObj.X + TempX < CellX And AWObj.X + TempX >= CellX - 1000) Then
                            XCheck = True
                        End If
                    End If
                    If AWObj.Z > 0 Then
                        If (AWObj.Z - TempZ > CellZ And AWObj.Z - TempZ <= CellZ + 1000) Or (AWObj.Z + TempZ > CellZ And AWObj.Z + TempZ <= CellZ + 1000) Then
                            ZCheck = True
                        End If
                    Else
                        If (AWObj.Z - TempZ < CellZ And AWObj.Z - TempZ >= CellZ + 1000) Or (AWObj.Z + TempZ < CellZ And AWObj.Z + TempZ >= CellZ - 1000) Then
                            ZCheck = True
                        End If
                    End If
                    If XCheck And ZCheck Then
                        CheckCellForEncroachment = True
                        Exit Function
                    End If
                Next
            Next
        End If
    Next
    CheckCellForEncroachment = False
    'if no object is found that encroaches, exit
End Function


Public Sub ReadRegistryFile(FileName As String)
On Error GoTo ErrorHandler
'This function is processor intensive and
'only needs to be called once
Dim FirstSpace As Integer, Counter As Integer, NextSpace As Integer, X As Long, Z As Long
Set fs = CreateObject("Scripting.FileSystemObject")
Set a = fs.openTextFile(FileName, 1, False)
Dim TempObject As RegistryEntry
'here, a is the object that refers to the
'registry file
'loop through all the entries
Do
    Do
        f$ = a.readline()
        FirstSpace = InStr(1, f$, " ", vbTextCompare)
        Model$ = Left$(f$, FirstSpace - 1)
    Loop While Item(Model$) <> ""
    'the model is to the left of the first space
    For Counter = 1 To 4
        FirstSpace = InStr(FirstSpace + 1, f$, " ", vbTextCompare)
        'go ahead four spaces
    Next
    NextSpace = InStr(FirstSpace + 1, f$, " ", vbTextCompare)
    X = Val(Mid$(f$, FirstSpace + 1, NextSpace - (FirstSpace + 1)))
    'reset firstspace to the next space
    FirstSpace = InStr(NextSpace + 1, f$, " ", vbTextCompare)
    NextSpace = InStr(FirstSpace + 1, f$, " ", vbTextCompare)
    'watch for comments on the right hand side
    'instr returns zero on error
    If NextSpace = 0 Then NextSpace = Len(f$) + 1
    Z = Val(Mid$(f$, FirstSpace + 1, NextSpace - (FirstSpace + 1)))
    
    'add object
    Add Model$, X, Z
Loop While Not a.atendofstream()
'continue until end of file is reached
Set a = Nothing 'clear memory
Exit Sub

ErrorHandler:
If Err = 5 Then Resume Next 'invalid procedure call; model doesn't exist
End Sub


Public Function Add(Model As String, X As Long, Z As Long) As RegistryEntry
    'create a new object
    Dim objNewMember As RegistryEntry
    Set objNewMember = New RegistryEntry


    'set the properties passed into the method
    objNewMember.Model = Model
    objNewMember.X = X
    objNewMember.Z = Z
   
    mCol.Add objNewMember, Model

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As RegistryEntry
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

