Option Strict Off
Option Explicit On
Module modFormSupport
	
	'System tray declarations begin:
	'------------------------------
	Const MAX_TOOLTIP As Short = 64
	Const NIF_ICON As Short = &H2s
	Const NIF_MESSAGE As Short = &H1s
	Const NIF_TIP As Short = &H4s
	Const NIM_ADD As Short = &H0s
	Const NIM_MODIFY As Short = &H1s
	Const NIM_DELETE As Short = &H2s
	Const WM_MOUSEMOVE As Short = &H200s
	Const WM_LBUTTONDOWN As Short = &H201s
	Const WM_LBUTTONUP As Short = &H202s
	Const WM_LBUTTONDBLCLK As Short = &H203s
	Const WM_RBUTTONDOWN As Short = &H204s
	Const WM_RBUTTONUP As Short = &H205s
	Const WM_RBUTTONDBLCLK As Short = &H206s
	
	Private Structure NOTIFYICONDATA
		Dim cbSize As Integer
		Dim hwnd As Integer
		Dim uID As Integer
		Dim uFlags As Integer
		Dim uCallbackMessage As Integer
		Dim hIcon As Integer
		<VBFixedString(MAX_TOOLTIP),System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr,SizeConst:=MAX_TOOLTIP)> Public szTip As String
	End Structure
	Private nfIconData As NOTIFYICONDATA
	
	'UPGRADE_WARNING: Structure NOTIFYICONDATA may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
	Private Declare Function Shell_NotifyIcon Lib "shell32.dll"  Alias "Shell_NotifyIconA"(ByVal dwMessage As Integer, ByRef lpData As NOTIFYICONDATA) As Integer
	
	'---------------------------------
	'End system tray declarations
	
	Public Const TERRAIN_TRACK_COUNTERS As Boolean = True
	
	Public Enum FORM_STATE_TYPE
		FORM_STATE_READY
		FORM_STATE_LOGGING_IN
		FORM_STATE_ACTIVE
		FORM_STATE_TERMINATED
		FORM_STATE_DISCONNECTED
	End Enum
	
	Public Enum FORM_CONNECTION_STATE
		FORM_CONNECTION_ONLINE
		FORM_CONNECTION_OFFLINE
		FORM_CONNECTION_DISCONNECTED
	End Enum
	
	Public Const FORM_LOG_ERROR As String = "Error"
	Public Const FORM_LOG_ACTION As String = "Action"
	Public Const FORM_LOG_COMMAND As String = "Command"
	Public Const FORM_LOG_SAFEGUARD As String = "Safeguard"
	Public Const FORM_LOG_MESSAGE As String = "Message"
	
	Public FORM_CURRENT_STATE As FORM_STATE_TYPE
	
	Public Const TERRAIN_AWWAIT_INTERVAL As Integer = 50
	Public Const TERRAIN_QUEUE_INTERVAL As Integer = 10
	Public Const TERRAIN_AUTO_INTERVAL As Integer = 10000
	
	Public Const LB_SETTABSTOPS As Integer = &H192s
	
    'Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByRef lParam As Any) As Integer

	Public Sub FormSaveColumnSettings()
		
		With frmTerrainManager.DefInstance
			
			WriteToINI(.ActivityLog.ColumnHeaders(1).Width, "Columns", "Width1")
			WriteToINI(.ActivityLog.ColumnHeaders(2).Width, "Columns", "Width2")
			WriteToINI(.ActivityLog.ColumnHeaders(3).Width, "Columns", "Width3")
			WriteToINI(.ActivityLog.ColumnHeaders(4).Width, "Columns", "Width4")
            WriteToINI(.ActivityLog.ColumnHeaders(5).Width, "Columns", "Width5")
			
			WriteToINI(.ActivityLog.ColumnHeaders(1).Left, "Columns", "Left1")
			WriteToINI(.ActivityLog.ColumnHeaders(2).Left, "Columns", "Left2")
			WriteToINI(.ActivityLog.ColumnHeaders(3).Left, "Columns", "Left3")
			WriteToINI(.ActivityLog.ColumnHeaders(4).Left, "Columns", "Left4")
			WriteToINI(.ActivityLog.ColumnHeaders(5).Left, "Columns", "Left5")
			
		End With
		
	End Sub
	
	Public Sub FormGetColumnSettings()
		
		With frmTerrainManager.DefInstance
			
			'.ActivityLog.columnheaders(1) = GetFromINI "Columns", "Width1", IniPath(), .ActivityLog.Width / 3.7
			
			
		End With
		
	End Sub
	
	Public Sub FormSaveLogOptions()
		
		With frmTerrainManager.DefInstance
			
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(CStr(.chkFileLog.CheckState), "Logging", "Enabled", IniPath())
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(.txtFileLog.Text, "Logging", "File", IniPath())
			
		End With
		
	End Sub
	
	Public Sub FormGetLogOptions()
		
		With frmTerrainManager.DefInstance
			
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			.chkFileLog.CheckState = CShort(GetFromINI("Logging", "Enabled", IniPath(), "0"))
			'UPGRADE_WARNING: Couldn't resolve default property of object LogPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			.txtFileLog.Text = GetFromINI("Logging", "File", IniPath(), LogPath())
			
		End With
		
	End Sub
	
	Public Sub FormListInitialize()
		
		With frmTerrainManager.DefInstance.ActivityLog
			.ColumnHeaders.Add( ,  , "Date/Time")
			.ColumnHeaders.Add( ,  , "Type")
			.ColumnHeaders.Add( ,  , "Privilege")
			.ColumnHeaders.Add( ,  , "Name")
			.ColumnHeaders.Add( ,  , "Message")
			.ColumnHeaders(1).Width = VB6.PixelsToTwipsX(.Width) / 3.7
			.ColumnHeaders(2).Width = VB6.PixelsToTwipsX(.Width) / 7
			.ColumnHeaders(3).Width = VB6.PixelsToTwipsX(.Width) / 7
			.ColumnHeaders(4).Width = VB6.PixelsToTwipsX(.Width) / 7
			.ColumnHeaders(5).Width = VB6.PixelsToTwipsX(.Width) / 3.5
		End With
		
	End Sub
	
	Public Sub FormDeleteFromSystemTray()
		
		Call Shell_NotifyIcon(NIM_DELETE, nfIconData)
		
	End Sub
	Public Sub FormDisableAutoLogin()
		
		'Disable login checkbox, save changes to INI, and restore form to visible
		With frmTerrainManager.DefInstance
			
			'Nofity user that auto-login is disabled
			If .chkAutoLogin.CheckState = 1 Then
				FormWriteToLog(FORM_LOG_MESSAGE,  ,  , "Auto-login has been disabled.")
				
			End If
			
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(CStr(0), "World", "AutoLogin", IniPath())
			.chkAutoLogin.CheckState = System.Windows.Forms.CheckState.Unchecked
			.mnuRestore_Click(frmTerrainManager.DefInstance.mnuRestore, New System.EventArgs())
			
		End With
		
	End Sub
	
	Public Sub FormMouseMove(ByVal Button As Short, ByVal Shift As Short, ByVal X As Single, ByVal Y As Single)
		
		Dim lMsg As Single
		'
		' Determine the event that happened to the System Tray icon.
		' Left clicking the icon displays a message box.
		' Right clicking the icon creates an instance of an object from an
		' ActiveX Code component then invokes a method to display a message.
		'
		
		'No need to check anything here if the form isn't minimized
		If frmTerrainManager.DefInstance.WindowState <> 1 Then Exit Sub
		
		lMsg = X / VB6.TwipsPerPixelX
		Select Case lMsg
			Case WM_LBUTTONUP
				frmTerrainManager.DefInstance.mnuRestore_Click(frmTerrainManager.DefInstance.mnuRestore, New System.EventArgs()) 'restore form
			Case WM_RBUTTONUP
				'popup menu
				'UPGRADE_ISSUE: Form method frmTerrainManager.PopupMenu was not upgraded. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup2064"'
				frmTerrainManager.PopupMenu(frmTerrainManager.DefInstance.mnuPopup,  ,  ,  , frmTerrainManager.DefInstance.mnuRestore)
				'Case WM_MOUSEMOVE
				'Case WM_LBUTTONDOWN
				'Case WM_LBUTTONDBLCLK
				'Case WM_RBUTTONDOWN
				'Case WM_RBUTTONDBLCLK
				'Case Else
		End Select
		
	End Sub
	
	
	Public Sub FormAddToSystemTray()
		
		' Add this application's icon to the system tray.
		'
		' Parm 1 = Handle of the window to receive notification messages
		'          associated with an icon in the taskbar status area.
		' Parm 2 = Icon to display.
		' Parm 3 = Handle of icon to display.
		' Parm 4 = Tooltip displayed when cursor moves over system tray icon.
		'
		With nfIconData
			.hwnd = frmTerrainManager.DefInstance.Handle.ToInt32
			.uID = CInt(CObj(frmTerrainManager.DefInstance.Icon))
			.uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
			.uCallbackMessage = WM_MOUSEMOVE
			'UPGRADE_ISSUE: Picture property Icon.Handle was not upgraded. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup2064"'
			.hIcon = frmTerrainManager.DefInstance.Icon.Handle
			.cbSize = Len(nfIconData)
		End With
		Call Shell_NotifyIcon(NIM_ADD, nfIconData)
		
	End Sub
	
	Public Sub LogoutWithError(ByRef ErrorMessage As String)
		
		FormWriteToLog(FORM_LOG_ERROR,  ,  , ErrorMessage)
		FormSetState(FORM_STATE_TYPE.FORM_STATE_TERMINATED)
		FormSetConnectState(FORM_CONNECTION_STATE.FORM_CONNECTION_OFFLINE)
		mAWSDK.aw_destroy()
		mAWSDK.aw_term()
		FormDisableAutoLogin()
		Exit Sub
		
	End Sub
	
	Public Sub FormLogoutWithErrorAndRecover(ByRef ErrorMessage As String)
		
		FormWriteToLog(FORM_LOG_ERROR,  ,  , ErrorMessage)
		FormSetState(FORM_STATE_TYPE.FORM_STATE_READY)
		FormSetConnectState(FORM_CONNECTION_STATE.FORM_CONNECTION_OFFLINE)
		mAWSDK.aw_destroy()
		FormDisableAutoLogin()
		Exit Sub
		
	End Sub
	
	Public Function IniPath() As Object
		'This function fixes an undesirable behavior in VB6 where the
		'app.path property is inconsistent
		'UPGRADE_WARNING: Couldn't resolve default property of object IniPath. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		If Right(VB6.GetPath, 1) = "\" Then IniPath = VB6.GetPath & "demeter.ini"
		'UPGRADE_WARNING: Couldn't resolve default property of object IniPath. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		If Right(VB6.GetPath, 1) <> "\" Then IniPath = VB6.GetPath & "\demeter.ini"
	End Function
	
	Public Function LogPath() As Object
		'This function fixes an undesirable behavior in VB6 where the
		'app.path property is inconsistent
		'UPGRADE_WARNING: Couldn't resolve default property of object LogPath. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		If Right(VB6.GetPath, 1) = "\" Then LogPath = VB6.GetPath & "log.txt"
		'UPGRADE_WARNING: Couldn't resolve default property of object LogPath. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		If Right(VB6.GetPath, 1) <> "\" Then LogPath = VB6.GetPath & "\log.txt"
	End Function
	
	Public Sub SaveLoginOptions()
		
		With frmTerrainManager.DefInstance
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(.txtPassword.Text, "Login", "PrivilegePassword", IniPath())
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(.txtTargetWorld.Text, "Login", "World", IniPath())
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(.txtUserId.Text, "Login", "CitizenNumber", IniPath())
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(.txtUniHost.Text, "Login", "UniHost", IniPath())
			'UPGRADE_WARNING: Couldn't resolve default property of object IniPath(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			WriteToINI(.txtUniPort.Text, "Login", "UniPort", IniPath())
		End With
		
	End Sub
	
	
	
	Public Sub FormSetState(ByVal formState As FORM_STATE_TYPE, Optional ByRef altStateText As String = vbNullString)
		
		Dim loginEnabled As Boolean
		Dim logEnabled As Boolean
		Dim stateText As String
		
		With frmTerrainManager.DefInstance
			Select Case formState
				Case FORM_STATE_TYPE.FORM_STATE_READY
					stateText = "Ready"
					loginEnabled = True
					logEnabled = False
					
				Case FORM_STATE_TYPE.FORM_STATE_LOGGING_IN
					stateText = "Logging In"
					loginEnabled = False
					logEnabled = False
					
				Case FORM_STATE_TYPE.FORM_STATE_ACTIVE
					stateText = "Active"
					loginEnabled = False
					logEnabled = True
					
				Case FORM_STATE_TYPE.FORM_STATE_TERMINATED
					stateText = "Terminated: Restart Required"
					loginEnabled = False
					logEnabled = False
					
				Case FORM_STATE_TYPE.FORM_STATE_DISCONNECTED
					stateText = "Disconnected; Reconnecting..."
					loginEnabled = False
					logEnabled = False
					
			End Select
			
			FORM_CURRENT_STATE = formState
			
			.lblTitleTargetWorld.Enabled = loginEnabled
			.lblTitleCitNum.Enabled = loginEnabled
			.lblTitlePassword.Enabled = loginEnabled
			.lblUniHost.Enabled = loginEnabled
			.lblUniPort.Enabled = loginEnabled
			
			.txtTargetWorld.Enabled = loginEnabled
			.txtUserId.Enabled = loginEnabled
			.txtPassword.Enabled = loginEnabled
			.txtUniHost.Enabled = loginEnabled
			.txtUniPort.Enabled = loginEnabled
			.fLogin.Enabled = loginEnabled
			
			.pbLogin.Enabled = loginEnabled
			VB6.SetDefault(.pbLogin, loginEnabled)
			
			'.ActivityLog.Enabled = logEnabled
			'.fLog.Enabled = logEnabled
			
			.lblState.Text = IIf(altStateText = vbNullString, stateText, altStateText)
			.lblState.Refresh()
			
			If loginEnabled And .Visible Then .txtPassword.Focus()
			
			'update tray icon tool tip text
			FormUpdateIconToolTip()
			
		End With
		
	End Sub
	
	Public Sub FormUpdateIconToolTip()
		
		Dim stateText As String
		
		'Check to see if tray icon is visible and update it to new text
		With frmTerrainManager.DefInstance
			
			'Nothing needs to be done here if the form is visible
			'The only time something is done is when the tray icon is visible and
			'The form is invisible
			If Not .Visible Then
				
				Select Case FORM_CURRENT_STATE
					Case FORM_STATE_TYPE.FORM_STATE_READY
						stateText = "Ready"
						
					Case FORM_STATE_TYPE.FORM_STATE_LOGGING_IN
						stateText = "Logging In"
						
					Case FORM_STATE_TYPE.FORM_STATE_ACTIVE
						stateText = "Active"
						
					Case FORM_STATE_TYPE.FORM_STATE_TERMINATED
						stateText = "Terminated"
						
					Case FORM_STATE_TYPE.FORM_STATE_DISCONNECTED
						stateText = "Disconnected"
						
				End Select
				
				nfIconData.szTip = "Demeter - " & stateText & " - " & "Markers:" & Left(.lblMarkerCount.Text, Len(.lblMarkerCount.Text) - 1) & ", Avatars:" & Left(.lblAvatarCount.Text, Len(.lblAvatarCount.Text) - 1) & ", Sessions:" & Left(.lblTerrainCount.Text, Len(.lblTerrainCount.Text) - 1) & vbNullChar
				'All of this is necessary because spaces are inserted on the form
				'after the numbers in the labels
				
				Call Shell_NotifyIcon(NIM_MODIFY, nfIconData)
				
			End If
			
		End With
		
	End Sub
	
	Public Sub FormWriteToLog(ByVal logType As String, Optional ByVal privNum As Integer = -1, Optional ByVal avName As String = "", Optional ByVal messageText As String = "")
		
		On Error GoTo ErrorHandler
		
		With frmTerrainManager.DefInstance.ActivityLog.ListItems
			If (.Count > 1000) Then .Remove(.Count)
			.Add(1,  , CDate(Now))
		End With
		
		With frmTerrainManager.DefInstance.ActivityLog.ListItems(1)
			.SubItems(1) = logType
			
			If privNum = -1 Then 'not specified, this is an error
				.SubItems(2) = vbNullString
			Else
				.SubItems(2) = CStr(privNum)
				
			End If
			
			.SubItems(3) = avName
			.SubItems(4) = messageText
		End With
		
		'Prevent infinite recursion
		If Left(messageText, 25) = "Unable to write to file -" Then
			Exit Sub
			
		End If
		
		With frmTerrainManager.DefInstance
			If .chkFileLog.CheckState = 1 Then
				FileOpen(1, .txtFileLog.Text, OpenMode.Append)
				PrintLine(1, CDbl(CStr(Now) & Space(25 - Len(Now)) & logType & Space(12 - Len(logType))) + IIf(privNum = -1, vbNullString, its(privNum)) + CDbl(Space(8 - Len(IIf(privNum = -1, vbNullString, its(privNum))))) + CDbl(avName) + CDbl(Space(20 - Len(avName))) + CDbl(messageText))
				
				FileClose(1)
				
			End If
			
		End With
		
		Exit Sub
		
ErrorHandler: 
		FormWriteToLog(FORM_LOG_ERROR,  ,  , "Unable to write to file - use the 'Browse' button to select a log file")
		FileClose(1)
		
	End Sub
	
	Public Sub FormSetMarkerCount(ByVal markerCount As Integer)
		
		If TERRAIN_TRACK_COUNTERS Then
			With frmTerrainManager.DefInstance.lblMarkerCount
				.Text = markerCount & " "
				.Refresh()
				
			End With
		End If
		
	End Sub
	
	Public Function FormCalcCellsInWorld() As Object
		
		'Returns the number of cells in the world
		'UPGRADE_WARNING: Couldn't resolve default property of object FormCalcCellsInWorld. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		FormCalcCellsInWorld = (TERRAIN_WORLD_COORD_SIZE * 2 + 1) ^ 2
		
	End Function
	
	
	Public Sub FormSetCellCount(ByVal cellCount As Integer)
		
		If TERRAIN_TRACK_COUNTERS Then
			With frmTerrainManager.DefInstance.lblCellCount
				.Text = cellCount & " "
				.Refresh()
				
			End With
			
			FormSetPercentQueried()
			
		End If
		
	End Sub
	
	Public Function FormGetPercentQueried() As Object
		
		'Gets the percentage queried for the world in string format
		'UPGRADE_WARNING: Couldn't resolve default property of object FormCalcCellsInWorld(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		'UPGRADE_WARNING: Couldn't resolve default property of object TerrainGetCellCount(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		'UPGRADE_WARNING: Couldn't resolve default property of object FormGetPercentQueried. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		FormGetPercentQueried = VB6.Format(TerrainGetCellCount() * 100 / FormCalcCellsInWorld(), "##0.000") & "% "
		
	End Function
	
	Public Sub FormSetPercentQueried()
		
		With frmTerrainManager.DefInstance.lblPercentQueried
			If TERRAIN_TRACK_COUNTERS Then
				'division calculates percentage of cells in world
				'that have been queried
				'UPGRADE_WARNING: Couldn't resolve default property of object FormGetPercentQueried(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
				.Text = FormGetPercentQueried()
				If .Text = "100.000% " Then .ForeColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
				.Refresh()
				
			Else
				'avoid divide by zero error if not tracking
				.Text = " "
				
			End If
			
		End With
		
	End Sub
	
	Public Sub FormSetAvatarCount(ByVal avatarCount As Integer)
		
		With frmTerrainManager.DefInstance.lblAvatarCount
			.Text = avatarCount & " "
			.Refresh()
			
		End With
		
	End Sub
	
	Public Sub FormSetTerrainSessionCount(ByVal terrainSessionCount As Integer)
		
		With frmTerrainManager.DefInstance.lblTerrainCount
			.Text = terrainSessionCount & " "
			.Refresh()
			
		End With
		
	End Sub
	
	Public Sub FormSetCellsInWorld()
		
		With frmTerrainManager.DefInstance.lblCellsInWorld
			'square of width of world in cells
			'UPGRADE_WARNING: Couldn't resolve default property of object FormCalcCellsInWorld(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
			.Text = FormCalcCellsInWorld() & " "
			.Refresh()
			
		End With
		
	End Sub
	
	
	Public Sub FormSetWorldName(ByVal worldName As String)
		
		With frmTerrainManager.DefInstance.lblWorld
			.Text = worldName & " "
			.Refresh()
			
		End With
		
	End Sub
	
	Public Sub FormSetConnectState(ByVal connectState As FORM_CONNECTION_STATE)
		
		With frmTerrainManager.DefInstance.lblConnectState
			
			Select Case connectState
				Case FORM_CONNECTION_STATE.FORM_CONNECTION_ONLINE
					.Text = "Online "
				Case FORM_CONNECTION_STATE.FORM_CONNECTION_OFFLINE
					.Text = "Offline "
				Case FORM_CONNECTION_STATE.FORM_CONNECTION_DISCONNECTED
					.Text = "Disconnected "
			End Select
			
			.Refresh()
			
		End With
		
	End Sub
End Module